/*
 * PgGraph.java
 *
 * Created on December 5, 2004, 6:17 PM
 */

package Grapher2D.geom;

import java.awt.Color;

import jv.function.PuFunction;
import jv.number.PuDouble;
import jv.object.PsPanel;
import jv.geom.PgPolygon;
import jv.number.PdColor;
import jv.number.PuInteger;
import jv.object.PsDebug;
import Grapher2D.util.PuDomain;



/**
 *
 * @author David
 */
public class PgGraph extends PgPolygon {

        protected       PuFunction                      m_func2;
        protected       PuDomain                        m_domain;
        protected       boolean                         m_bHasVf = false;
        protected       boolean                         m_bUseGlobalDomain = false;
        protected       double[]                        globaldomain;
        
	public PgGraph(String PName) {
            super(2);
	    if (getClass() == PgGraph.class)
		  init(PName);
	}
        
	public void init(String PName) {
               
            super.init();
            setName(PName);
                  
  
                    setGlobalEdgeColor(Color.black);
                    
                    m_func2 = new PuFunction(1,1);
                    m_func2.setName("Functions");
                    m_func2.setVariables(new String[] {"x"});
                    m_func2.setExpressionNames(new String[] {"y"});
                    m_func2.setExpressions(new String[] {"x^2"});
                    m_func2.setParent(this);
                    
                    m_domain = new PuDomain();
                    m_domain.setVars(new String[] {"x"});
                    m_domain.setDefDiscr(new int[] {50});
                    m_domain.init();
                    m_domain.setParent(this);
                    
                    showVertices(false);
                    setGlobalEdgeSize(2);
                    
                    computeGraph();
		
 	}
	public void start() {
		if (PsDebug.NOTIFY) PsDebug.notify("start: ");

	}
	/**
	 * Update the class whenever a child has changed.
	 * Method is usually invoked from the children.
	 */
	public boolean update(Object event) {
		if (event == this) {
                        computeGraph();
			return super.update(this);
		} else if (event == m_domain) {
                        update(this);
			return true;
                } else if (event == m_func2) {
                        update(this);
			return true;
                }
                
		return super.update(event);
	}

	public void computeGraph() {
            
                int xlines = m_domain.getDiscr(0);
                double x = m_domain.getMin(0);

                double deltaX= (m_domain.getMax(0)-x)/(xlines-1.);
               
                double y;
                

                int numVertices = xlines;
                if (numVertices == 1)
			return;
		setNumVertices(numVertices);
               
                int ind = 0;
		for (int i=0; i<xlines; i++) {
                     y = m_func2.eval(x);
                     setVertex(ind,x,y);
                    ind++;
                    x += deltaX;
		}
		
            
	}
        
        public void setDomain(double[] domain) {
            if (m_bUseGlobalDomain) {
                m_domain.setVals(domain);
                update(this);
            } else {
                globaldomain = domain;
            }
            
        }
        
        
    
}
