/*
 * PgImpSurf_CP.java
 *
 * Created on December 5, 2004, 6:20 PM
 */

package Grapher2D.geom;

import java.awt.*;

import java.awt.event.*;
import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import Grapher2D.util.*;
/**
 *
 * @author David
 */
public class PgImpSurf_CP extends PsPanel implements ActionListener, ItemListener, FocusListener {
        protected	PgImpSurf                               m_PgImpSurf;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       TextField                               m_tText;
        protected       Checkbox                                m_cUseGlobalDomain;

    
    /** Creates a new instance of PgImpSurf_CP */
    public PgImpSurf_CP() {
        super();
        if (getClass() == PgImpSurf_CP.class) {
            init();
        }
    }
    
     public void init() {
		super.init();
		addTitle("Graph");
             
                m_pFunc = new PsPanel();
                m_pFunc.setLayout(new GridLayout(1, 1));
                add(m_pFunc);
                
		m_pDomain = new PsPanel();
  		add(m_pDomain);
		
		addLine(1);
    }
    
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgImpSurf = (PgImpSurf)parent;
                
                setTitle("Implicit Curve " + m_PgImpSurf.getName());
                
//                m_pFunc.add(m_PgImpSurf.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_tText = new TextField();
                if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPSURF){
                    m_tText.setText("x^2+y^2=16");
                } else if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPPOLAR) {
                    m_tText.setText("r=2*cos(t)+1");
                }
                m_tText.addActionListener(this);
                m_tText.addFocusListener(this);
               
                m_PgImpSurf.setEqn(m_tText.getText());
                
                m_pFunc.add(m_tText);
                m_pDomain.add(m_PgImpSurf.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                
                if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPSURF) {
                    m_cUseGlobalDomain = new Checkbox("Use Global Domain");
                    m_cUseGlobalDomain.addItemListener(this);
                    m_pDomain.add(m_cUseGlobalDomain);
                }

                
        }
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}
    public void actionPerformed(ActionEvent event) {
		
		Object source = event.getSource();
                if (source == m_tText) {
                    m_PgImpSurf.setEqn(m_tText.getText());
                }
    }
    public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source == m_cUseGlobalDomain) {
                    m_PgImpSurf.m_bUseGlobalDomain = m_cUseGlobalDomain.getState();
                    m_PgImpSurf.m_domain.setEnabled(!m_PgImpSurf.m_bUseGlobalDomain);
                    if (m_PgImpSurf.m_bUseGlobalDomain) {
                        m_PgImpSurf.setDomain(m_PgImpSurf.globaldomain);
                    }
                }
    }
    
    public void focusGained(FocusEvent e) {
    }
    
    public void focusLost(FocusEvent e) {
        Object source = e.getSource();
                if (source == m_tText) {
                    m_PgImpSurf.setEqn(m_tText.getText());
                }
    }
    
}
