/*
 * PgVecFldOn.java
 *
 * Created on December 5, 2004, 6:21 PM
 */

package Grapher2D.geom;

import java.awt.Color;
import jv.function.PuFunction;
import jv.number.PuDouble;
import jv.object.PsPanel;
import jv.geom.PgPointSet;
import jv.number.PdColor;
import jv.number.PuInteger;
import jv.object.PsDebug;
import jv.vecmath.PdVector;
import jv.vecmath.PiVector;
import jv.geom.PgVectorField;
import Grapher2D.util.PuDomain;
/**
 *
 * @author David
 */
public class PgVecFldOn extends PgVectorField {
    protected       PuFunction                      m_func2;
    protected       PuDomain                        m_domain;
    
    /** Creates a new instance of PgVecFldOn */
    public PgVecFldOn(String Pname) {
        super(2, PgVectorField.VERTEX_BASED);
        if (getClass() == PgVecFldOn.class) {
            init(Pname);
        }
    }
    
    public void init(String Pname) {
         super.init();
        setName(Pname);
        
        m_func2 = new PuFunction(2,2);
        m_func2.setName("Functions");
        m_func2.setVariables(new String[] {"x","y"});
        m_func2.setExpressionNames(new String[] {"dx","dy"});
        m_func2.setExpressions(new String[] {"-y","x"});
        m_func2.setParent(this);
        
        m_domain = new PuDomain();
        m_domain.setVars(new String[] {"x","y"});
        m_domain.setDefVals(new double[] {-5.0,5.0});
        
        m_domain.setNumDiscr(0);
        m_domain.setIsVF(true);
        m_domain.init();
        m_domain.setParent(this);
       
 //       assureVectorColors();
        showIndividualMaterial(true);
        showVectorArrows(true);
        setGlobalVectorColor(Color.black);
     
       
       
        
    }
    
    public void start() {
		if (PsDebug.NOTIFY) PsDebug.notify("start: ");
    }

    public boolean update(Object event) {
		if (event == this) {
                        computeVfos();
			return super.update(this);
		} else if (event == m_domain) {
                    update(this);
                    
                } else if (event == m_func2) {
                    update(this);
                }
                return true;
    }
    
    public void computeVfos() {
          
            int numVertices;
            numVertices = getGeometry().getNumVertices();
           
            setNumVectors(numVertices);
            
            int i;
            double x,y;
            
            
            for (i=0; i<numVertices;i++) {
                                double[] inp;
                                inp = getGeometry().getVertex(i).getEntries();
      			
                                x = m_func2.eval(0,inp);
                                y = m_func2.eval(1,inp);
                                
                                
                                double scl;
                                if (m_domain.isSclVecs()) {
                                    double length = Math.sqrt(x*x+y*y);
                                    scl = m_domain.getVeclength()/(length+0.1);
                                } else {
                                    scl = m_domain.getVeclength()/10.;
                                }
                                
                               setVector(i,x*scl,y*scl);
                              
                    
            }
      
        }
    
    
    
    
}
