/*
 * ImageSelection.java
 *
 * Created on December 27, 2004, 8:50 AM
 */

package Grapher2D.util;

import java.awt.*;
import java.awt.datatransfer.*;

/**
 * Handles clipboard elements.  Code from Sun's website
 *
 * @author David Lippman
 * @version 1.0.122704
 */

public class ImageSelection implements Transferable {
        private Image image;
    
        public ImageSelection(Image image) {
            this.image = image;
        }
    
        // Returns supported flavors
        public DataFlavor[] getTransferDataFlavors() {
            return new DataFlavor[]{DataFlavor.imageFlavor};
        }
    
        // Returns true if flavor is supported
        public boolean isDataFlavorSupported(DataFlavor flavor) {
            return DataFlavor.imageFlavor.equals(flavor);
        }
    
        // Returns image
        public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
            if (!DataFlavor.imageFlavor.equals(flavor)) {
                throw new UnsupportedFlavorException(flavor);
            }
            return image;
        }
    }
